=== debian/changelog ===
highs (1.11.0+ds-1) unstable; urgency=medium

  * New upstream version 1.11.0+ds.
  * d/patches: refresh existing patches.
  * d/rules: update FULLVERSION to 1.11.0.
  * d/copyright: update according to upstream.

 -- Shengqi Chen <harry@debian.org>  Fri, 15 Aug 2025 00:19:07 +0800
