=== debian/control ===
Source: highs
Section: science
Priority: optional
Standards-Version: 4.7.2
Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Shengqi Chen <harry@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-sequence-python3,
               help2man,
               libz-dev,
               libcatch2-dev <!nocheck>,
               ninja-build,
               pybuild-plugin-pyproject,
               python3-dev,
               python3-numpy,
               python3-pybind11,
               python3-pytest <!nocheck>,
               python3-scikit-build-core
Homepage: https://highs.dev/
Vcs-Git: https://salsa.debian.org/science-team/highs.git
Vcs-Browser: https://salsa.debian.org/science-team/highs
Rules-Requires-Root: no

Package: libhighs1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: highs
Description: High performance linear optimization software (shared library)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the libhighs1 shared library.

Package: python3-highspy
Section: python
Architecture: any
Depends: libhighs1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: High performance linear optimization software (Python library)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the Python library for HiGHS.

Package: libhighs-dev
Section: libdevel
Architecture: any
Depends: libhighs1 (= ${binary:Version}), ${misc:Depends}
Description: High performance linear optimization software (development files)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the development files for libhighs.

Package: highs
Architecture: any
Depends: libhighs1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: High performance linear optimization software
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the HiGHS solver.
