## highs 1.12.0+ds

=== check/CMakeLists.txt ===
--- 
+++ 
@@ -48,6 +48,7 @@
       TestHighsRbTree.cpp
       TestHighsSparseMatrix.cpp
       TestHighsVersion.cpp
+      TestHipo.cpp
       TestHSet.cpp
       TestICrash.cpp
       TestIis.cpp
@@ -106,6 +107,8 @@
 
   add_executable(unit_tests ${TEST_SOURCES})
 
+  set_target_properties(unit_tests PROPERTIES UNITY_BUILD OFF)
+
   if (UNIX)
       target_compile_options(unit_tests PRIVATE "-Wno-unused-variable")
       target_compile_options(unit_tests PRIVATE "-Wno-unused-const-variable")
@@ -258,7 +261,7 @@
       "lseu\;1120|1119.9999999\;"
       "egout\;(568.1007|568.1006999)\;"
       "gt2\;21166\;"
-      "rgn\;82.1999992\;"
+      "rgn\;82.19999\;"
       "bell5\;(8966406.49152|8966406.491519|8966406.49151)\;"
       "sp150x300d\;(69|68.9999999)\;"
       "p0548\;(8691|8690.9999999)\;"
@@ -376,7 +379,3 @@
       list(GET instance 0 name)
       list(GET instance 1 iter)
 
-      if(${solutionstatus} STREQUAL "Optimal")
-          list(GET instance 2 optval)
-      endif()
-
