=== debian/changelog ===
highs (1.12.0+ds-1) unstable; urgency=medium

  * d/watch: switch to version 5.
  * New upstream version 1.12.0+ds.
  * d/patches: refresh existing patches.
  * d/patches: remove more hardcoded RPATH settings from CMake.
  * d/rules: update FULLVERSION to 1.12.0.
  * d/rules: set CMAKE_BUILD_TYPE to None.

 -- Shengqi Chen <harry@debian.org>  Sun, 09 Nov 2025 23:10:18 +0800
