=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 SOVERSION=1
-FULLVERSION=1.11.0
+FULLVERSION=1.12.0
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -22,7 +22,7 @@
 	-C skbuild.ninja.version=">=1.5" \
 	-C skbuild.build.verbose=true \
 	-C skbuild.install.strip=false \
-	-C skbuild.cmake.build-type=RelWithDebInfo \
+	-C skbuild.cmake.build-type=None \
 	-C skbuild.cmake.args=-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
 	-C skbuild.cmake.args=-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
 	-C skbuild.cmake.args=-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
